SmartGit 17.1.6 (2018-03-28)
============================
New Features, Improvements
--------------------------
- Log, Tools menu: allow tools that operate on the repository using
  ${repositoryRootPath}

Fixed Bugs
----------
- Git:
  - Git-Flow: when merging, stop processing if merge aborts due to file
    permission problems
  - Refresh: possible internal error for special characters in file name and
    wrong system charset
  - Stash Selection: contained redundant "--" when invoking "git stash push"


SmartGit 17.1.5 (2018-02-21)
============================
New Features, Improvements
--------------------------
- built-in SSH client: support for diffie-hellman-group-exchange-sha256

Fixed Bugs
----------
- Git:
  - Log:
    - Compare:
      - Linux/GTK2: possible internal error painting comments
      - too large font was used for comments
- SVN: changing URL did not work reliable - disabled
- Bitbucket: possible 401 authentication failures after redoing OAuth
  authentication while SmartGit is running


SmartGit 17.1.4a (2018-02-15)
=============================

Compatibility with GitHub's discontinued support for weak cryptographic standards

https://githubengineering.com/crypto-deprecation-notice/


SmartGit 17.1.4 (2018-01-30)
============================
New Features, Improvements
--------------------------
- Git:
  - External Diff tools:
    - set system property "smartgit.core.cat.applyFilters" to true to apply
      filter.<name>.smudge
  -System property "smartgit.executable.home" supports $USERPROFILE on Windows
- support for Git 2.16's SSH client detection ("The SSH server '-G' could not be
  found")

Fixed Bugs
----------
- Git:
  - after a fresh setup, "Mark as Favorite" notification comes up again every
    couple of seconds when dismissing with red x
  - Changes view, Index Editor: staging LF-only files converted it to CRLF in
    Index
  - Investigate: Open Log may result in internal error if Blame was not yet
    initialized
  - Log:
    - Branches: toggling single branch in unselected category may add additional
      2nd-level branch to selection
    - Changes: Compact Changes option did not work (regression)
  - Refresh: internal error related to renamed files
- User interface:
  - Preferences, Text Editor colors: ruler colors were not applied/stored
  - OS X: possible internal error related to connecting/disconnecting monitors
  - update check: did remind user to enable update check while it was disabled
    by system property


SmartGit 17.1.3 (2017-12-06)
============================
New Features, Improvements
--------------------------
- Log: the count of the loaded commits is now hidden by default (set
  smartgit.log.commits.showLoadedCount to true to show it)
- JIRA integration: option smartgit.jira.fixResolutionId to specify the
  issue resolution ID that should be used to mark issues as resolved
- set smartgit.updateCheck.checkForLatestBuildVisible to false to hide
  Help | Check for Latest Build
- Investigate: don't require DeepGit license for licensed SmartGit users

Fixed Bugs
----------
- Git:
  - Merge, Abort and others: could not be invoked if .gitmodules was in
    conflicting state
  - Refresh:
    - include with relative path like ../.gitconfig did not work in .git/config
    - wrong display after creating orphan branch
  - Review comments: not able to add first comment to file


SmartGit 17.1.2 (2017-11-14)
============================
New Features, Improvements
--------------------------
- Git:
  - Abort: made more clear that aborting will perform 'git reset --hard'
    discarding all local changes
- large company license handling:
  - added system property "smartgit.license.defaultPath" to change the location
    of default license file (instead of "<install-dir>/default/license")
  - if license file is expired, silently update license file from default
    license file location

Fixed Bugs
----------
- Git:
  - Background fetch: fetched even unregistered or inactive submodules
  - Commit: in merging state "Commit All Changes" for a modified, renamed file
    resulted in "pathspec did not match any files" error
  - Commit/Rebase Continue: did not abort in case of conflicts but committed them
  - Compare/Changes view: "as-is" files (.gitattributes: -text) were checked out
    with wrong line-endings
  - Git-Flow, Integrate: fixed in structions for system Git-Flow
  - Journal: under certain conditions 3 columns were used where 2 would have
    been sufficient
  - Refresh: possible internal error
- Compare, Index Editor, ...:
  - Shift+Del did not cut any more (Windows, Linux)


SmartGit 17.1.1 (2017-10-26)
============================
New Features, Improvements
--------------------------
- Git:
  - Commit: set VM option smartgit.commit.checkForValidUserNameAndEmail to false
    to disable the check for a user name and email
  - Log: shows repository name in title similar to repository window
  - menu items "Help | Check for New Version" and "Help | Check for Latest Build"
    are hidden now if smartgit.disableCheckForNewVersion is set to true
  - menu item "Help | Register" can be hidden by setting
    smartgit.registerEnabled to false
- External Tools: support ${fileName}
- more options for user/seat tracking

Fixed Bugs
----------
- Git:
  - Blame: - internal error if empty file content was encountered
  - refresh:
    - internal errors if paths contained special unicode characters, e.g. İ
      (large i with dot)
    - refresh on window activation did not work if there were file monitor
      problems
    - infinite refreshing when opening repository at drive root, e.g. C:\
  - submodule related internal error
- Compare/Changes: internal error if selecting binary file and
  smartgit.compare.skipBinaryComparison was set to true
- External Tools: directory tools were shown on closed repositories regardless
  of configured name pattern
- GUI:
  - maximized state was not restored at correct coordinates/monitor
  - Windows: for configured zoom factor 250% the 100% zoom factor was be used


SmartGit 17.1 (2017-10-12)
==========================
Other Changes
-------------
- SmartGit can be started with Java 9 if smartgit.startup.allowJava9=true is set

Fixed Bugs
----------
- Hg: could not open compare on "merged" files
- SWT: IME-related exception, e.g. when clear Chinese text


SmartGit 17.1 RC 4 (2017-10-10)
===============================
Other Changes
-------------
- SmartGit requires the use of Java 1.8 - it will reject to work with Java 1.9

New Features, Improvements
--------------------------
- Git:
  - Cherry-Pick and other commands: only fetch submodules if necessary
    (regardless of "Always fetch submodules" option)

Fixed Bugs
----------
- Git:
  - Git-Flow (System), Finish Feature: remote operations like fetching develop
    might not work
  - Cherry Pick with conflicts: showed "Success" popup
- Linux:
  - internal error opening repository with Java 1.9
  - assertion showing the Investigate/DeepGit-register dialog


SmartGit 17.1 RC 3 (2017-10-06)
===============================
New Features, Improvements
--------------------------
- Mercurial:
  - support for Mercurial 4.3
- GUI:
  - Default selection background color is customizable

Fixed Bugs
----------
- Git:
  - Refresh (Linux, Mac): possible performance problems due to bad ctime-check
- GUI:
  - Branches, Files view: Pull should not be available in context menu
  - Open: was opening repository root instead of file
  - Repositories view: should not offer Ignore in context menu
    for closed repositories


SmartGit 17.1 RC 2 (2017-10-03)
===============================
New Features, Improvements
--------------------------
- Git:
  - Fetch can be added as toolbar button
  - Push: popup menu contains Push to Gerrit
  - Journal: increased default for common commits from 10 to 50
- Conflict Solver: added toolbar button to make showing base file changes more
  obvious
- GUI:
  - Linux: don't support full-screen option on i3 tiling window manager

Fixed Bugs
----------
- Git:
  - Log: fixed problems in Files view and Changes view for displaying review
         comments with HiDPI monitors (4K)
  - Push and Pull commands were not available in Repositories view context menu
    for multi-repository selections
  - Stash: the "Include untracked files" option was not migrated correctly
- GUI:
  - Fixed instructions for GitLab
- OS X bundle contained outdated Git version

Other Changes
-------------
- DeepGit requires the use of Java 1.8 - it will not (yet) work with Java 1.9


SmartGit 17.1 RC 1 (2017-09-25)
===============================
New Features, Improvements
--------------------------
- Git
  - Journal, Modify or Split Commit:
    - Split: optionally use just 1 commit by setting
      smartgit.rebase.split.use2Commits=false

Fixed Bugs
----------
- Git:
  - Journal: Modify or Split Commit was broken
- Linux:
  - single-item completion popup was to small on some Linux systems
  - output success popup causes focus loss for saving in Index Editor and for
    background fetch
  - using the Mate desktop caused dialogs to not get activated reliably


SmartGit 17.1 preview 17 (2017-09-20)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Journal: show more merged, e.g. between BEHIND and AUXILIARY
- GUI:
  - Compare, Index Editor, Conflict Solver: ability to edit even files with
    mixed (inconsistent) line-endings, because it would take longer to wait for
    fixes for applications writing such files, e.g. Arduino IDE
  - Output dialog:
    - added context menu to message part supporting copy and word-wrap
    - support more minor warnings to be ignored, e.g. when
      "CRLF will be replaced by LF in <file path>."
  - Preferences: added option to restore all confirmation dialogs
  - Push: don't allow for branches tracking another local branch
- Refresh:
  - refresh on window activation should be more responsive now

Fixed Bugs
----------
- Git:
  - Background fetch: might produce output dialog on failure though it only
    should show a popup
  - Commit message: was not cleared sometimes after successful commit
  - JIRA: failed to resolve after having swapped commits
  - Journal: clicking to expand commits did not work reliable
  - Rebase (incl. Pull): auto-stashing changes might not work (regression)
  - Refresh:
    - internal error when having sparse checkout with .gitignore files
    - symlinks on Windows (created with mklink) always showed up as modified
- Linux: Linux Mint with Mate desktop did not activate the welcome dialog


SmartGit 17.1 preview 16 (2017-09-14)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Branches, Delete Ref: refined dialogs
  - Cherry-Pick: show progress, especially for SVN submodule update
  - Investigate: open log
  - Journal:
    - Create and check out branch
    - improved display of collapsed nodes
    - expand collapsed commits by clicking the collapsed node
  - Preferences: option to enable GIT_TRACE logging
  - Submodules:
    - added option to repository settings dialog to push submodules on demand
    - Deactive command to mark inactive/unwanted submodules (relying on new Git
      "submodule.<name>.active" flag)
  - Unstage: now also available for intent-to-add files
- GUI:
  - preferences: remembers previously used (and still available) Git and Hg
    executables for easier switching between alternative installations
  - system dependent dialog button order can now be overridden by setting
    smartgit.dialog.buttonsRightAligned to true or false
- Company setup
  - if current license file is expired and a new one is available in the default
    directory, it will be copied automatically from there
  - "smartgit.properties" is copies from default-directory

Fixed Bugs
----------
- Git:
  - Push: pushing tag did not work (tag was not pushed)
  - Push/Pull: duplicated error message shown in command failed dialog
  - Refresh: renamed files in submodule had from source-path configured, e.g.
    resulting in displaying an empty HEAD content in the Changes view
  - Sync: JIRA issues were not resolved if first pulling then pushing and
    incoming changes were present, so a rebase was required
  - "Use pre-installed (system) Git-Flow" option was lost after setup
- Tools:
  - did not show up any more for closed repositories
- GUI:
  - Linux: on some systems an extreme DPI value was returned causing weird
    effects, e.g. 200% scaling with very small x on tabs

Other Changes
-------------
- Windows, OS X: updated Java to version 1.8.0_144


SmartGit 17.1 preview 15 (2017-09-08)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Changes: improved performance
  - Distributed Review add-on: template for Pull Request Integration
    configurable
    https://www.syntevo.com/doc/pages/viewpage.action?pageId=1704359#DistributedReviews(add-on)-Customizingthepullrequestintegrationmessage)
  - External tools: ${repositoryRootPath} is now also supported for closed
    repositories
  - Files view:
    - context menu: if a submodule is selected, inappropriate menu items
      are not shown any more
  - Investigate: made dark-theme-capable
  - Log:
    - Details: made gravatar image clickable to see large image in browser
  - Push To dialog (for refs): removed "Force" option if modifying pushed
    commits is disabled in preferences
  - Refresh:
    - ignores missing or bad refs
    - show notification about possible performance problems if much refs
      were detected
    - the regular expressions to limit the number of loaded tags/remote
      branches is now configurable in the repository's .git/config (see
      notificaton)
  - Refresh (after command execution): more responsive if Branches view is
    still updating
  - Stash Selection: support for untracked files
  - Submodule, Update: "And initialize new submodules" option recurses now
    by default, unless smartgit.submoduleUpdate.initializeRepository=true
- GUI:
  - own toolbar implementation:
    - popup buttons will show the popup on mouse-release or long-click,
      instead of on mouse-down
    - buttons with additional popup menu will only show the popup on long
      click if the option smartgit.toolbar.longClickPopupOnly is set true
- Windows, OS X bundles: upgraded Git to version 2.14.1

Fixed Bugs
----------
- Git:
  - Branches: Set Tracked Branch could suggest wrong branch
  - Changes: changed line-endings were shown for changed submodule
  - Commit: comparing added file in staged mode showed working tree changes
  - Log:
    - Delete was enabled if no branch or tag was selected
  - Refresh problem after replacing entire repository ("can't find commit")
  - merge/rebase/cherry-pick failed with serious error for mild errors like
    conflicts - now with a warning
- SVN:
  - Refresh: internal error when opening SVN clone with submodules
- Delete: could not delete dangling link (Linux)
- GUI:
  - Changes: fixed possible internal error switching from compact to normal
    display
  - F2 in the Files view triggered rename stash instead of rename file
  - Preferences: Add/Edit external tool dialog rejected invalid but disabled
    confirmation message
  - Windows 10: table header was hardly distinguishable from normal rows


SmartGit 17.1 preview 14 (2017-08-31)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Gerrit:
    - support for drafts and topics
    - Push To Gerrit: should be available from Repositories view
  - Journal, Split Commit: apply the commit two times for easier splitting
  - Push:
    - should behave more similar when invoked in main window and from Branches view/Log
    - Push dialog: option to "don't show again"
  - Stash:
    - improved stash management
    - option "Include untracked files" moved to Preferences
    - quick-stash actions (no message)
  - "Git executable is not valid."-dialog: make the link to stackoverflow clickable
- GUI:
  - Compare, Apply Selection: allow to operate with selections outside blocks
  - allow to skip "SmartGit needs to check for updates" dialog at startup

Fixed Bugs
----------
- Git:
  - Branches view: opening a Log from right-clicking a branch did not reveal it
    (if View|Include Tracked Remote Branches is selected in Log)
  - Push: pushing multiple branches (from Branches view) did not correctly evaluate force-flag
  - Refresh:
    - after commands: did not update renamed missing files
    - avoid useless scanning into ignored directories
    - duplicate submodule was displayed after replacing directory tree by submodule
    - obstructed conflicts should be reported
  - Stash:
    - automatic stash after commands: should honor "Include untracked" option
    - selection stashing: message was always "Created via 'git stash store'"
- GUI:
  - Changes: applying something caused line separator changes to disappear
  - Commit, Select Message from Log: did not put focus into message editor anymore


SmartGit 17.1 preview 13 (2017-08-21)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Cleanup renamed to "Run Garbage Collector"
  - Commit: warning "Do you want to commit and push just a subset of all changes"
    can be hidden
  - Conflict Solver: added preferences options to swap "ours" and "theirs" in
    case of rebase conflicts
  - Ignore:
    - works on newly removed files, too
    - works on tracked files, too, by removing them
  - Log:
    - drag and drop operations show a popup menu at the drop location instead
      of a dialog
    - 2 toolbar buttons for Log Repository and Log Selection, each having the
      other in the popup menu
  - Pull: added Fetch and Fetch More commands as popup menu items
  - Push: toolbar button with Push-To in popup menu
  - Refresh:
    - performance improvements (up to 30% faster were reported)
    - added preferences option to inspect EOLs for modified files
      (former system property "smartgit.refresh.inspectEOLs")
  - Stash: ability to rename (only the stash, not the created commits!)
- Hg:
  - 2 toolbar buttons for Log Repository and Log Selection, each having the
    other in the popup menu
- SVN:
  - smartgit.svn.authorsfile uses UTF-8 encoding now
- GUI:
  - Commit Message input field: prevent entering/pasting 0x00 characters
  - verbose date: added option in the preferences to disable the "Yesterday" display
  - own toolbar implemenation:
    -  smaller area to trigger popup (means larger area for triggering the
       normal command), because the popup also can be activated by click and hold

Fixed Bugs
----------
- Git:
  - Branches: renamed stash did not show new name (stash commit still show the
    original names because the stash is not recreated but just renamed)
  - Changes: showed "EOL: Unix" on Windows for HEAD vs. Index comparison
  - Commit: newly check for set user name and email did not consider .git/config
  - Log:
    - Checkout: fixed warning trying to check out origin/foo if foo was *behind*
      origin/foo
  - Output: could not be cleared completely manually
  - Pull: "Fetch merge type no specified" error
  - Refresh:
    - possible phantom modifications when having "ident" attribute set
    - possible duplicate refreshing after executed commands
  - Startup: "--investigate" opened annotate instead of DeepGit if SmartGit
    already was running
- GUI:
  - Compare:
    - Apply Selection was often not predictable
    - possible invalid inner-line diff
  - Clone wizard: the remote branch combobox could increase the dialog's with
  - double-clicking renamed file did not open file compare
  - Syntax coloring (Windows): file extension case did matter
  - own toolbar implementation:
    - different spaces between icon/text and popup arrow

Other Changes
-------------
- renamed "line separators" to "line-endings" because the latter seems more
  commonly used
- updated SWT to version 4.811


SmartGit 17.1 preview 12 (2017-08-02)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Changes view: option to ignore line separator changes
  - Commit: if user.name or user.email are not set, a warning is shown
  - Journal:
    - added option to show more commits (temporarily until branch or repository
      is switched)
    - added system properties "smartgit.log.commitMessage.lineFeedSymbol"
      and "smartgit.log.commitMessage.shortOnlyTitle" (default: true)
  - Log Repository: added separate menu item and toolbar button (with popup for
    log for selection)
  - Pull (multiple repositories): option to fetch tags
  - Repository Settings:
    - completely reworked to edit effective repository values;
    - options from .git/smartgit.config moved to .git/config ("smartgit" section)
- GUI:
  - date formatting: show weekday for previous week

Fixed Bugs
----------
- Git:
  - Changes view:
    - empty lines with different line separators did not show line separators
    - line separator was shown for last line of files that ended with "normal"
      character (no line separator) even if all line separators were equal
    - wrong index line separators files configured with text = auto in
      .gitattributed
    - Index vs. HEAD showed "EOL: Unix expected Windows" by default on Windows
    - toggling "Ignore Whitespace" hid line separator changes
  - Git-LFS: recursive patterns like "image/**" were not properly interpreted
  - Investigate: fixed a few visual glitches, especially on HiDPI monitor
  - Output popup: showed success even if cherry pick or external commands failed
  - Proxy: if .gitconfig contained server-specific proxy, it was overridden by
    the proxy configured in SmartGit
  - Repository Settings: can't clear user settings, e.g. for GPG program
- GUI:
  - OS X: selected/toggled state of own toolbar was hard to notice


SmartGit 17.1 preview 11 (2017-07-21)
=====================================
New Features, Improvements
--------------------------
- Support for line-based line separators:
  - Changes view: should show them
  - Compare only shows the file content
  - Compare, Index Editor, Conflict Solver: prevent editing when mixed line
    separators were detected (in that case, please first fix the mixed line
    separators using a text editor)
- Author column: support for "LastName, FirstName"
- Git:
  - Log:
    - Files: distinguish between "Renamed" and "Renamed-Modified"
  - separated Save Stash to Stash All and Stash Selection
  - Stash All: ability to "Just Save" (= stash and re-apply)
  - Stash Selection: file name completion
- Output view:
  - hidden by default
  - if hidden, shows just a plain auto-hiding popup or failure dialog
    with command output
  - upon user request the failure dialog can be replaced by an failure
    auto-hiding popup
  - preferences: removed options to show command and directory - they are
    always shown now
- GUI:
  - completion popup now completes with <tab> and <enter>

Fixed Bugs
----------
- Git:
  - Branches: remote branches inside directory-like sections showed section prefix
  - Investigate/DeepGit was broken
  - Push: JIRA issue were not resolved
- GUI:
  - Linux: shell bounds are not remembered correctly, work-around for
    https://bugs.eclipse.org/bugs/show_bug.cgi?id=519808
  - OS X: table columns in dialogs, e.g. commit, were to narrow by default

Other Noteworthy Changes
------------------------
- OS X: updated Git to version 2.13.1 (if updating installation)
- Windows: updated Git to version 2.13.3 (if updating installation); default
  credentials manager is disabled


SmartGit 17.1 preview 10 (2017-07-10)
=====================================
New Features, Improvements
--------------------------
- Git:
  - Branches view: section-nodes are sorted according to user choice (name,
    date), not always the last one
  - Changes view: added context menu item to open in Index Editor (at same
    position)
- GUI:
  - Changes view: optional compact display (option can be found in Changes menu)
  - Author column shortening:
    - Foo-Bar Bazz now can be truncated to F.-B. Bazz or FBB
    - can be disabled by setting smartgit.authorColumn.smartShortening=false

Fixed Bugs
----------
- Git:
  - Log:
    - possible hang if increasing rectilinearity, combined with preserve parent
      order
    - Details: parents may not be displayed if not yet loaded into the graph
  - Refresh: possible "error-prone admin area configuration" for cascading,
    unrelated repositories
- GUI:
  - accelerator input field: Ctrl+A selected instead of detecting accelerator
  - modifying accelerators kept previous accelerators in windows mapping
  - Ctrl+- and Ctr+Numpad- triggered the same commands

Other Noteworthy Changes
------------------------
- Git: uses native rebase now instead of own code that worked around the
  long-time performance problems of "git rebase" on Windows


SmartGit 17.1 preview 9 (2017-06-16)
====================================
New Features, Improvements
--------------------------
- Git:
  - Log:
    - improved preserving of colors (requires Git-Flow to be enabled)
    - option to force preservering parent order (requires system property
      "smartgit.log.graph.layoutActions" set to true)
- Hg:
  - support version numbers like 4.2+309-f40...
- SVN:
  - Push: support for resolving JIRA issues

Fixed Bugs
----------
- Git:
  - Rebase:
    - "Continue" button may add unexpected additional commit
  - Refresh: submodules might not be refreshed anymore after switching back
    from ignored submodule


SmartGit 17.1 preview 8 (2017-05-18)
====================================
New Features, Improvements
--------------------------
- Git:
  - Distributed Reviews add-on: option to read users from CSV file
  - Fetch (more): --unshallow option
  - Ignore: ability to ignore multiple files explicitly
  - Pull (multiple repositories): honors configured "fetch tags" default from
    single pull dialog
  - Rebase, Continue: ask how to handle untracked files instead of rejecting
    to continue
  - Refresh: minor performance improvements in case of many refs/tags
- Hg:
  - support for Mercurial 4.2
- no dependency on GLIBC 2.14 any more, so it can run on 64-bit CentOS 6.*
- GUI:
  - the focused Changes view is treated like the Files view would be focused
  - own toolbar implementation to avoid a couple of toolbar bugs, especially on
    Linux:
    https://bugs.eclipse.org/bugs/show_bug.cgi?id=508033
    https://bugs.eclipse.org/bugs/show_bug.cgi?id=509220
    https://bugs.eclipse.org/bugs/show_bug.cgi?id=512716
    https://bugs.eclipse.org/bugs/show_bug.cgi?id=513115

Fixed Bugs
----------
- Git:
  - Branches: sectioned tags showed section name part (branches dodn't)
  - Distributed Reviews add-on: users may become deleted after editing
  - Log:
    - Changes: comments were painted over content on Linux
      https://bugs.eclipse.org/bugs/show_bug.cgi?id=511844
    - Branch Delete was allowed on git-svn branch but shouldn't
  - Refresh (Windows): performance problems when using junctions
  - Setup wizard: does not require email AND name any more
- Windows: periodic CPU usage of ~3%
- GUI:
  - Find and Replace dialog: Find buttons were not enabled when invoked on
    selected text


SmartGit 17.1 preview 7 (2017-04-25)
====================================
New Features, Improvements
--------------------------
- Git:
  - Branches view: reverse-digit-sorting is now configurable
  - Clone: remembers last target paths independent from local source path
  - Log: can be triggered now from renamed file (using the history from the
    deleted/missing partner)
  - support for "reverting state" (Refresh, Abort command)
  - Windows: updated bundled Git to version 2.12.2
- Hg:
  - support for version 4.1
- Compare:
  - Reload: preserves vertical scrolling
- Setup wizard: only trigger repository search for new users (== no known
  repository)

Fixed Bugs
----------
- Git
  - Clone: with "Fetch all commits" deselected, but then "Fetch all Heads and
    Tags" selected again, still only the latest X commits are fetched
  - Interactive rebase:
    - failed for submodules
    - failed if core.commentChar was defined
    - could show timeout dialog
  - Log: clustering commits fixes


SmartGit 17.1 preview 6 (2017-03-31)
====================================
New Features, Improvements
--------------------------
- Git:
  - Branches/Tags: numbers in names are sorted reverse
  - Changes view:
    - for renamed file shows HEAD of original file
  - Compare:
    - if invoked on a renamed file works like having the added/untracked and
      removed/missing file selected
    - if invoked on a submodule "file" shows same information as Changes view
  - Index Editor:
    - if Changes view is focused, the Index Editor is opened at the exact same place
    - for renamed files shows HEAD of original file
- dark theme: table header color can be set (especially on Windows)

Fixed Bugs
----------
- Git:
  - Commit: error invoking compare (by double-clicking) for added file
  - Compare: if invoked on a renamed file (pair), the original was not always shown left
  - Log:
    - Reveal even asked for Local vs. Tracked branch if both pointed to same commit
  - Preferences: changing "Detect renames" option did not refresh
  - Stage: error "pathspec <original-file-name> did not match any files" for renamed,
    modified files
- Password store: master password is reset to empty if no (more) passwords are
  present on exit
- OS X: Home key did not move caret to first document position if appropriate option
  in the preferences was unselected


SmartGit 17.1 preview 5 (2017-03-15)
====================================
New Features, Improvements
--------------------------
- Git
  - Clone: allow to specify the branch to check out
    https://smartgit.userecho.com/topics/152
  - DeepGit: various improvements and fixes
  - Repository/Directory popup: rearranged some menu items

Fixed Bugs
----------
- GUI:
  - OS X: disabling the parent window of a dialog caused to lose the focused control
    after the dialog had been dismissed
  - Tree controls: internal error if selected node has became unselected by
    collapsing a parent node


SmartGit 17.1 preview 4 (2017-03-09)
====================================
New Features, Improvements
--------------------------
- Git:
  - Add Tag: removed redundant "Create annotated tag" checkbox
    http://smartgit.userecho.com/topics/343
  - Branches view:
    - sort branches *and tags* in sections http://smartgit.userecho.com/topics/307
    - uses more descriptive "incoming pull requests" instead of showing "(!)"
  - Log: ability to open file with same path (ignoring any rename) in external tool
    http://smartgit.userecho.com/topics/180
- Changes view, Compare: Apply Line/Stage Line/Unstage Line: allow in (equal sized)
  change blocks
- Conflict Solver: ability to apply both (Left before Right, Right before Left)
  http://smartgit.userecho.com/topics/64

Fixed Bugs
----------
- Compare: closing the window could interfere with a previously triggered Save
  causing internal error
- speed-search popup was hard to read with dark theme


SmartGit 17.1 preview 3 (2017-02-24)
====================================
New Features, Improvements
--------------------------
- Git:
  - Add Tag dialog: added Ctrl+Space popup for filtering of existing tags
  - Journal:
    - Interactive Rebase: support Move & Squash (as in Journal) as for
      equally named commits
    - Modify and Split Commit: added Modify (for stopping after the commit) and
      Split (for stopping with commit changes in the Index) options
  - Log:
    - added Interactive Rebase for modifying the history of the head commit
- Compare:
  - quick precompare distinguishes between binary equal and content equal
    (except of line separators)
- Windows, Open in SmartGit: by defining smartgit.open.preferSingleWindow=true
  not a seperate window is opened, but one existing (even with already opened
  repository) is re-used

Fixed Bugs
----------
- Git:
  - Blame: Age and Author highlighting were not dark-theme-aware
  - Changes view: fixed EOL display for no-converting case, e.g. core.autocrlf = false
  - Journal:
    - Checkout was available even for the HEAD commit
    - Interactive Rebase: internal error if multiple commits were removed
  - Stash files:
    - possible internal error
    - problems related to added and removed files
- GUI:
  - Compare: markers for hidden inner-line changes hard to see on dark theme
  - full-screen and maximized/zoomed state were not distinguished
  - OS X: Enter Full-Screen has been moved from Windows to View menu


SmartGit 17.1 preview 2 (2017-02-16)
====================================
New Features, Improvements
--------------------------
- Git:
  - Stash selected files:
    - added to Files context menu
    - if 1 or more untracked files are selected, a warning (i) is shown and
      allowed to proceed
- GitHub/others: more appropriate validation of certificates
- GUI:
  - Compare, Conflict Solver: reworked Find, Find & Replace dialogs, added regular
    expression search, simplified next/prev handling
  - Notifications: more notifications with "Remind me later" option
  - Themes:
    - might extend using existing themes (extends=<theme-resource>)
    - might switch editor theme (preferredEditorTheme=[light|dark])
    - added command line parameter --write-default-theme-file for easier creation
      of own themes

Fixed Bugs
----------
- Blame: internal error
- Refresh:
  - on window activation refreshing failed if file monitoring was broken
  - after commands: might fail after perfroming tool operation
- GUI:
  - OS X: it was possible to close a parent dialog immediately after the child
    dialog while the child dialog's close handler wasn't performed


SmartGit 17.1 preview 1 (2017-01-30)
====================================
New Features, Improvements
--------------------------
- Git:
  - Changes view: if mixed line separators prevent staging/unstaging, an info is shown in the context menu
  - Commit:
    - if in rebasing-state and no committable change detected, Commit is not offered
    - if in rebasing-state Continue Rebase also works with unstaged changes
  - DeepGit: complete integration (no need for external DeepGit installation)
  - Journal:
    - batch process multiple changes (Rebase Interactive; <https://smartgit.userecho.com/topics/54>)
    - command to split commits
  - Log:
    - Reveal can work on remote or local branches regardless of display options
    - removed "Include Tracked Remote Branches" from Branches view context menu
      because it also influences Commits view
  - Pull, Fetch: offers to remove invalid fetch refspec from .git/config
  - Stash: works on selected files (<https://smartgit.userecho.com/topics/15>)
  - Sync: updates toolbar button according to configured pull-push order
  - Quickly locate (matching) gitignore files (<https://smartgit.userecho.com/topics/8>)

Fixed Bugs
----------
- Git:
  - Git-Flow: Finish Feature might fail if develop had submodule changes
